
#include "stdafx.h"
#include "DAQExample.h"
#include "DAQExampleDlg.h"

/* ------------------------------------------------------------------------ */
/* PortI/O                                                                  */
/* ------------------------------------------------------------------------ */

# pragma warning (disable:4201)
#include "WINIOCTL.H"
# pragma warning (default:4201)
#include "VxD_Nt_ADSer_def.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

class CAboutDlg : public CDialog
{
   public:
		CAboutDlg();
		
		//{{AFX_DATA(CAboutDlg)
		enum { IDD = IDD_ABOUTBOX };
		//}}AFX_DATA
		
		//{{AFX_VIRTUAL(CAboutDlg)
	   protected:
		   virtual void DoDataExchange(CDataExchange* pDX);
		//}}AFX_VIRTUAL
		
	protected:
		//{{AFX_MSG(CAboutDlg)
		//}}AFX_MSG
		DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
   //{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
   CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
   //{{AFX_MSG_MAP(CAboutDlg)
   //}}AFX_MSG_MAP
END_MESSAGE_MAP()

CDAQExampleDlg::CDAQExampleDlg(CWnd* pParent /*=NULL*/)
: CDialog(CDAQExampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDAQExampleDlg)
	m_Edit = _T("");
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_Running=0;
}

void CDAQExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDAQExampleDlg)
	DDX_Text(pDX, IDC_EDIT, m_Edit);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDAQExampleDlg, CDialog)
   //{{AFX_MSG_MAP(CDAQExampleDlg)
   ON_WM_SYSCOMMAND()
   ON_WM_PAINT()
   ON_WM_QUERYDRAGICON()
   ON_BN_CLICKED(IDC_START, OnStart)
   ON_BN_CLICKED(IDC_STOP, OnStop)
   ON_BN_CLICKED(IDC_PARAM, OnParam)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/* ------------------------------------------------------------------------ */
/* Funktionsname     : OpenComm                                             */
/* Hinweis           :                                                      */
/* Historie          : 09.03.2001 (Erstellung)                              */
/* ------------------------------------------------------------------------ */

HANDLE CDAQExampleDlg::OpenComm ( LPCSTR port, UINT cbInQueue, UINT cbOutQueue )
{
   HANDLE hComm=INVALID_HANDLE_VALUE; char *qupos; char Text[40];

   /* Backslash vor 'COMx:' setzen und Doppelpunkt dahinter entfernen ... */
   /* "\\.\COMx"  dadurch knnen Schnittstellen ber COM9 geffnet werden */
   /* Das geht nur in der 32 Bit Version, darum hier eingefgt            */
   strcpy ( Text, "\\\\.\\" );
   strcat ( Text, port);
   qupos = strrchr ( Text, ':' );
   if ( qupos != NULL )
      *qupos = '\0';

   hComm = CreateFile ( Text, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL );

   if ( hComm == INVALID_HANDLE_VALUE )
      return hComm;

   UNUSED(cbInQueue);
   UNUSED(cbOutQueue);

   return hComm;
}

/* ------------------------------------------------------------------------ */
/* Funktionsname     : FlushComm                                            */
/* Hinweis           :                                                      */
/* Historie          : 09.03.2001 (Erstellung)                              */
/* ------------------------------------------------------------------------ */

int CDAQExampleDlg::FlushComm ( HANDLE hComm, int fnQueue )
{
   if ( fnQueue == 0 )
      PurgeComm ( hComm, PURGE_TXCLEAR );
   else
      PurgeComm ( hComm, PURGE_RXCLEAR );

   return 0;
}

/* ------------------------------------------------------------------------ */
/* Funktionsname     : CloseComm                                            */
/* Hinweis           :                                                      */
/* Historie          : 09.03.2001 (Erstellung)                              */
/* ------------------------------------------------------------------------ */

int CDAQExampleDlg::CloseComm ( HANDLE hComm )
{
   return CloseHandle ( hComm );
}

/* ------------------------------------------------------------------------ */
/* Funktionsname     : Create_VxD_Sys                                       */
/* Hinweis           :                                                      */
/* Historie          : 09.03.2001 (Erstellung)                              */
/* ------------------------------------------------------------------------ */

BOOL CDAQExampleDlg::Create_VxD_Sys ()
{
   OSVERSIONINFO VersionInformation;

   char *ptr; int laenge1=0; int laenge2=0;
   char FAR ExeFileDir[300];
   char *bslPos;
   char TempString[260]; char szShortPath[260]; char VxDPath[260];

   // Betriebs-System Version feststellen
   memset ( &VersionInformation, 0, sizeof(VersionInformation) );
   VersionInformation.dwOSVersionInfoSize = sizeof(VersionInformation);
   GetVersionEx ( &VersionInformation );

   if ( VersionInformation.dwPlatformId == VER_PLATFORM_WIN32_NT )
		AfxMessageBox ("Windows NT/2000 nicht untersttzt");
	else
	{
      /* Verzeichnis in dem das EXE-File liegt */
      GetModuleFileName ( NULL, ExeFileDir, sizeof(ExeFileDir)-1 );

      bslPos = strrchr(ExeFileDir,'\\');
      if ( bslPos != NULL )
         *(bslPos+1) = '\0';
      else
         ExeFileDir[0] = '\0';

      strcpy ( TempString, ExeFileDir );

      ptr = strrchr ( TempString, 92 );
      laenge1 = strlen ( TempString );
      laenge2 = strlen ( ptr );
      if ( (laenge1-laenge2) < 0 )
         return TRUE;

      GetShortPathName ( TempString, szShortPath, _MAX_PATH );
      strcpy ( VxDPath, "\\\\.\\" );
	   strcat ( VxDPath, szShortPath );
	   strcat ( VxDPath, "\\" );
	   strcat ( VxDPath, "ADSer.VXD" );
      m_hCVxDSys = CreateFile( LPCTSTR(VxDPath), 0, 0, 0, CREATE_NEW, FILE_FLAG_DELETE_ON_CLOSE, 0 );
   }

   if( m_hCVxDSys == INVALID_HANDLE_VALUE )
      return TRUE;

   return FALSE;
}

/* ------------------------------------------------------------------------ */
/* Funktionsname     : Close_VxD_Sys                                        */
/* Hinweis           :                                                      */
/* Historie          : 09.03.2001 (Erstellung)                              */
/* ------------------------------------------------------------------------ */

BOOL CDAQExampleDlg::Close_VxD_Sys ()
{
   if ( m_hCVxDSys != INVALID_HANDLE_VALUE )
   {
	   CloseHandle( m_hCVxDSys );
      m_hCVxDSys = INVALID_HANDLE_VALUE;
      return TRUE;
   }

   return FALSE;
}

/* ------------------------------------------------------------------------ */
/* Funktionsname     : SCAN_Start                                           */
/* Hinweis           :                                                      */
/* Historie          : 09.03.2001 (Erstellung)                              */
/* ------------------------------------------------------------------------ */

int CDAQExampleDlg::SCAN_Start ( WORD wBaseAddress, UINT iNo, WORD iChannelPos[6], UINT count, UINT ms )
{
   BOOL bFlag=TRUE; ULONG nReturned=0;

   typedef struct { WORD wBaseAddress;
						  WORD iNo;
                    WORD iChannelPos[6];
                    WORD count;
                    WORD ms;
                    WORD Sleep;
						  WORD iRetTreiber; } PARAMETER;
   PARAMETER Param;

   Param.wBaseAddress = wBaseAddress;
	Param.iNo = (WORD)iNo;
   memcpy ( Param.iChannelPos, iChannelPos, 6*sizeof(WORD) );
	Param.count = (WORD)count;
	Param.ms = (WORD)ms;
	Param.Sleep = 20;
   Param.iRetTreiber	= 0;

   bFlag = DeviceIoControl( m_hCVxDSys, (DWORD) VXD_CTL_SCAN_START, &Param, sizeof(PARAMETER), &Param,	sizeof(PARAMETER), &nReturned, NULL );

   return bFlag ^= 1;
}

/* ------------------------------------------------------------------------ */
/* Funktionsname     : DAQ_HalfReady                                        */
/* Hinweis           :                                                      */
/* Historie          : 09.03.2001 (Erstellung)                              */
/* ------------------------------------------------------------------------ */

int CDAQExampleDlg::DAQ_HalfReady ( BOOL *bHalfReady, BOOL *bDAQstopped )
{
   BOOL bFlag=TRUE; ULONG nReturned=0;

   typedef struct { WORD bHalfReady;
						  WORD bDAQstopped;
						  WORD iRetTreiber; } PARAMETER;
   PARAMETER Param;

   Param.bHalfReady	= FALSE;
   Param.bDAQstopped	= FALSE;
   Param.iRetTreiber	= 0;

   bFlag = DeviceIoControl( m_hCVxDSys, (DWORD) VXD_CTL_DAQ_HALFREADY, &Param, sizeof(PARAMETER), &Param,	sizeof(PARAMETER), &nReturned, NULL );

   *bHalfReady = Param.bHalfReady;
   *bDAQstopped = Param.bDAQstopped;

   return bFlag ^= 1;
}

/* ------------------------------------------------------------------------ */
/* Funktionsname     : DAQ_Transfer                                         */
/* Hinweis           :                                                      */
/* Historie          : 09.03.2001 (Erstellung)                              */
/* ------------------------------------------------------------------------ */

int CDAQExampleDlg::DAQ_Transfer ( DWORD *mprVal )
{
   BOOL bFlag=TRUE; ULONG nReturned=0;

   typedef struct { DWORD *mprVal;
						  WORD iRetTreiber; } PARAMETER;
   PARAMETER Param;

   Param.mprVal = mprVal;
   Param.iRetTreiber	= 0;

   bFlag = DeviceIoControl( m_hCVxDSys, (DWORD) VXD_CTL_DAQ_TRANSFER, &Param, sizeof(PARAMETER), &Param,	sizeof(PARAMETER), &nReturned, NULL );

   return bFlag ^= 1;
}

/* ------------------------------------------------------------------------ */
/* Funktionsname     : DAQ_Clear                                            */
/* Hinweis           :                                                      */
/* Historie          : 09.03.2001 (Erstellung)                              */
/* ------------------------------------------------------------------------ */

int CDAQExampleDlg::DAQ_Clear ( )
{
   BOOL bFlag=TRUE; ULONG nReturned=0;

	typedef struct { WORD iRetTreiber; } PARAMETER;
	PARAMETER Param;

   Param.iRetTreiber	= 0;

   bFlag = DeviceIoControl( m_hCVxDSys, (DWORD) VXD_CTL_DAQ_CLEAR, &Param, sizeof(PARAMETER), &Param,	sizeof(PARAMETER), &nReturned, NULL );

   return bFlag ^= 1;
}

/* ------------------------------------------------------------------------ */
/* Funktionsname     : Init                                                 */
/* Hinweis           :                                                      */
/* Historie          : 09.03.2001 (Erstellung)                              */
/* ------------------------------------------------------------------------ */

int CDAQExampleDlg::Init()
{
   WORD wBaseAddress=0x0000;

   /* Mit Windows API-Funktionen wird getestet, ob die COM-Schnittstelle */
   /* verwendet werden kann.                                             */
   HANDLE iComID = INVALID_HANDLE_VALUE;

   switch ( m_Param.m_Com )
   {
      case 0:
         iComID = OpenComm ( "COM1:", 0, 0 );
         wBaseAddress=0x3f8;
         break;
      case 1:
         iComID = OpenComm ( "COM2:", 0, 0 );
         wBaseAddress=0x2f8;
         break;
      default:
         break;
   }
   
   if ( iComID == INVALID_HANDLE_VALUE )
   {
		AfxMessageBox ("Fehler beim ffnen der seriellen Schnittstelle.");
		return NICHT_OK;
   }

   FlushComm ( iComID, 1 );
   FlushComm ( iComID, 0 );

   /* Test mit Windows API-Funktion beenden */
   CloseComm ( iComID );

   /* Feld zur Aufnahme der Mewerte (mit Blockgre) anlegen */
   switch ( m_Param.m_BlockSize )
   {
      case 0:
      default:
         m_count=512;
         break;
   }

   mprVal=NULL; mprVal = new DWORD[ m_count ];

   /* Kanal-Liste aufbauen */
   m_iChannelPos[0]=m_Param.m_Channel;

   /* Abtastrate in Millisekunden */
   switch ( m_Param.m_Sampling )
   {
      case 0:
      default:
         m_ms=1;
         break;
   }

   m_hCVxDSys = INVALID_HANDLE_VALUE;

   int iRet = Create_VxD_Sys ();
   if( iRet )
   {
		AfxMessageBox ("Der VxD-Treiber konnte nicht geffnet werden.");
		return NICHT_OK;
   }

   iRet = SCAN_Start ( wBaseAddress, 1, m_iChannelPos, m_count, m_ms );
   if( iRet )
   {
		AfxMessageBox ("Messung konnte nicht gestartet werden.");
		return NICHT_OK;
   }

   return OK;
}

/* ------------------------------------------------------------------------ */
/* Funktionsname     : Fetch                                                */
/* Hinweis           :                                                      */
/* Historie          : 09.03.2001 (Erstellung)                              */
/* ------------------------------------------------------------------------ */

int CDAQExampleDlg::Fetch()
{
   BOOL bHalfReady=FALSE; BOOL bDAQstopped=FALSE;

   int iRet = DAQ_HalfReady ( &bHalfReady, &bDAQstopped );
   if( iRet )
		return NICHT_OK;

   /* Pufferberlauf ? */
   if ( bDAQstopped )
		return NICHT_OK;

   /* Puffer zur Abholung bereit ? */
   if ( bHalfReady )
      return RECHENBEREIT;

   return NICHT_RECHENBEREIT;
}

/* ------------------------------------------------------------------------ */
/* Funktionsname     : Execute                                              */
/* Hinweis           :                                                      */
/* Historie          : 09.03.2001 (Erstellung)                              */
/* ------------------------------------------------------------------------ */

int CDAQExampleDlg::Execute()
{
   /* Puffer ist fertig, wird ausgelesen */
   int iRet = DAQ_Transfer ( mprVal );
   if( iRet )
		return NICHT_OK;

   return OK;
}

/* ------------------------------------------------------------------------ */
/* Funktionsname     : Done                                                 */
/* Hinweis           :                                                      */
/* Historie          : 09.03.2001 (Erstellung)                              */
/* ------------------------------------------------------------------------ */

int CDAQExampleDlg::Done()
{
   DAQ_Clear ();
   Close_VxD_Sys ();

   /* Feld zur Aufnahme der Mewerte lschen */
   if ( mprVal ) delete [] mprVal; mprVal=NULL;

   return OK;
}

void CDAQExampleDlg::SchalteControlFeldAus ( UINT ControlFeld[40] )
{
   UINT uiFeldPos=0;
	CWnd *wH;
   
   uiFeldPos = 0;
	while ( ControlFeld[uiFeldPos] != 0 )
   {
	   wH = ( CWnd * ) GetDlgItem ( ControlFeld[uiFeldPos] );
		wH->EnableWindow( FALSE );
      uiFeldPos++;
   } 
}

void CDAQExampleDlg::SchalteControlFeldEin ( UINT ControlFeld[40] )
{
   UINT uiFeldPos=0;
	CWnd *wH;
   
   uiFeldPos = 0;
	while ( ControlFeld[uiFeldPos] != 0 )
   {
	   wH = ( CWnd * ) GetDlgItem ( ControlFeld[uiFeldPos] );
		wH->EnableWindow( TRUE );
      uiFeldPos++;
   } 
}

BOOL CDAQExampleDlg::OnInitDialog()
{
   CDialog::OnInitDialog();
	
	// Hinzufgen des Menbefehls "Info..." zum Systemmen.
	
	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);
	
	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
	   CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{	
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
   }
	
	SetIcon ( m_hIcon, TRUE );
	SetIcon ( m_hIcon, FALSE );

   return TRUE;
}

void CDAQExampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
   if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CDAQExampleDlg::OnPaint() 
{
   if (IsIconic())
	{
	   CPaintDC dc(this); // Gertekontext fr Zeichnen
		
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);
		
		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;
		
		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CDAQExampleDlg::OnQueryDragIcon()
{
   return (HCURSOR) m_hIcon;
}

CString SysTime()
{
	SYSTEMTIME systime;
	GetSystemTime(&systime);
	CString tmp;
	tmp.Format ("%d.%d", systime.wSecond, +systime.wMilliseconds);
	return tmp;
}

void CDAQExampleDlg::OnStart() 
{
   UINT ControlFeld[] = {IDC_PARAM, IDOK, 0};

   if (m_Running)
		return;

   int iRet = Init ();
   if ( iRet != OK )
		return;

   m_Running= TRUE;

   SchalteControlFeldAus ( ControlFeld );

   TRACE ("Start DAQ: %s\n", SysTime());

   m_Timer= SetTimer ( 1, 10, NULL );
}

void CDAQExampleDlg::OnStop() 
{
   UINT ControlFeld[] = {IDC_PARAM, IDOK, 0};

   if (!m_Running)
		return;

   m_Running= FALSE;

   SchalteControlFeldEin ( ControlFeld );

   KillTimer ( m_Timer );

   TRACE ("Stop DAQ: %s\n", SysTime());

   Done ();
}

void CDAQExampleDlg::OnParam() 
{
	if (m_Running)
		OnStop();

   m_Param.DoModal();
}

void CDAQExampleDlg::OnTimer(UINT nIDEvent) 
{
   double a=0.0, b=0.0, x1=0.0, x2=0.0, y1=0.0, y2=0.0;

   TRACE ("Entry TimerFkt: %s\n", SysTime());

   int iRet = Fetch ();
   if ( iRet == NICHT_OK )
	   OnStop();

   if ( iRet == RECHENBEREIT )
   {
		TRACE ("TimerFkt HalfReady: %s\n", SysTime());

      iRet = Execute ();
      if ( iRet == NICHT_OK )
	      OnStop();

      CString tmp;

      m_Edit.Empty();

      tmp.Format ( "%d\n", m_count );
		m_Edit+= tmp;

      /* Je nach Kanal Skalierung der Mewerte auf Spannung */
      switch ( m_Param.m_Channel )
      {
         case 0:
            x1=0.0; x2=1024.0; y1=-5.0;  y2=5.0;  a = (y2 - y1) / (x2 - x1); b = y1 - a * x1;
            break;
         case 1:
            x1=0.0; x2=1024.0; y1=0.0;   y2=10.0; a = (y2 - y1) / (x2 - x1); b = y1 - a * x1;
            break;
         case 2:
            x1=0.0; x2=1024.0; y1=-10.0; y2=10.0; a = (y2 - y1) / (x2 - x1); b = y1 - a * x1;
            break;
         case 3:
            x1=0.0; x2=1024.0; y1=-10.0; y2=10.0; a = (y2 - y1) / (x2 - x1); b = y1 - a * x1;
            break;
         case 4:
            x1=0.0; x2=1024.0; y1=0.0;   y2=10.0; a = (y2 - y1) / (x2 - x1); b = y1 - a * x1;
            break;
         case 5:
            x1=0.0; x2=1024.0; y1=-5.0;  y2=5.0;  a = (y2 - y1) / (x2 - x1); b = y1 - a * x1;
            break;
         default:
            break;
      }

      /* Mewerte Block anzeigen */
      for ( UINT i=0; i<m_count; i++ )
      {
         double dVal = (double)(a * mprVal[i] + b);
         tmp.Format ( "%.4f ", dVal );
			m_Edit+= tmp;
			if ((i+1)%11==0)
				m_Edit+= "\n";
		}

      UpdateData (FALSE);
   }

   CDialog::OnTimer (nIDEvent);

   TRACE ("Exit TimerFkt: %s\n", SysTime());
}
